#include <stdio.h>

int main(void)
{
	long n;
	long i;

	scanf ("%ld",&n);
	
	// Kreiramo nizove i inicijalizuj ih.
	
	long r[n];
	long c[n];
	
	for (i=0; i<n; i++)
	{
		r[i]=0;
		c[i]=0;
	}
	
	char t[n][n];
	
	long y,x;
	
	for (y=0; y<n; y++)
	{
		for (x=0; x<n; x++)		
		{
			t[y][x]=0;
		}
	}
	
	char ima_za_pomeranje=0;

	for (i=0; i<n; i++)
	{
		scanf ("%d %d", &y, &x);
		
		r[y-1]++;
		c[x-1]++;
		
		if (r[y-1]>1 || c[x-1]>1)
			ima_za_pomeranje=1;
	}
	
	// 
	// Glavni deo.
	//
	
	if (n==1)
	{
		printf("0");
	}
	else if (n==2)
	{
		if (ima_za_pomeranje==0)
			printf("0");
		else
			printf("1");
	}
}